#!/usr/bin/perl
use strict;
use warnings;

use DateTime;
use Net::FTP;
use Net::Telnet;
use File::Path;
use File::Copy;
use File::Touch;
use Archive::Zip;
use DateTime::TimeZone::Tzfile;

my $tz = DateTime::TimeZone::Tzfile->new('/etc/localtime');

#Рабочая директория
my $basedir="/opt/M200/cdr";

my $dt = DateTime->now(time_zone  => $tz);

my $filenamemask="cdr_log_".$dt->dmy('_').".*";

my $curhour=$dt->hour;

my $curhour_str;

if ($curhour<10) {$curhour_str="0".$curhour;} else {$curhour_str=$curhour;}

unless (-e "$basedir/jrn" ) {
	mkpath("$basedir/jrn");
} 

unless (-e "$basedir/err" ) {
	mkpath("$basedir/err");
} 

#Параметры подключения к ftp АТС
my $ftpobj = Net::FTP -> new ("192.168.1.1");
$ftpobj -> login("user","pass");
$ftpobj -> cwd ("/TARIF/CDR");
my @index = $ftpobj -> ls($filenamemask);

foreach my $file (@index) {
	my $year;
	my $month;
	my $day;
	my $i;
	my $newhour=0;

	print "Processing $file...\n";
	$ftpobj -> get ("$file","$basedir/$file");
	if ( $file =~ m/cdr_log_(\d\d)_(\d\d)_(\d\d\d\d).log/ ) {
		$year=$3;
		$month=$2;
		$day=$1;
		mkpath("$basedir/$year/$month");

		for ($i = 0; $i <=$curhour; $i++) {
			my $hour;
			if ($i<10) { $hour="0".$i; } else { $hour = $i; }
			touch("$basedir/$year/$month/$day"."_$hour.notzipped");
		}

		open FILE, "$basedir/$file" or die $!;
		while (<FILE>) {
	  		$_ =~ m/\d\d\.\d\d\.\d\d\d\d.(\d\d).*/;
	   		my $outfile = "$basedir/$year/$month/$day"."_$1.notzipped";
			$_ =~ s/\-/0000000000/g;
			if ( $_ =~ s/(^.+\t\d+)\t(4962219\d{3})\t(\d*?4962219\d{3})\t(\d+)\t(\d+)\t(.*)$/$1\t$2\t$2\t$4\t$4\t$6/ ) {
				print "0: $_";
			}
			elsif ( $_ =~ s/(^.+\t\d+)\t(\d+)\t(\d+)\t(\d*?2219\d{3})\t(4962219\d{3})\t(.*)$/$1\t$3\t$3\t$5\t$5\t$6/ ) {
				print "1: $_";
			} else {
				print "2: $_";
			}
				
			open (OUTFILE, ">>$outfile");
				print OUTFILE "$_";
	 		close (OUTFILE); 
		}
		close(FILE);

		my @dir = `ls "$basedir/$year/$month" | grep .notzipped`;

		foreach my $tozip(@dir) {
			$tozip =~ s/\n//;
			my $zipped = $tozip;
			$zipped =~ s/.notzipped$//;
			print "Zipping $tozip... New name is $zipped\n";
			my $zobj = Archive::Zip->new();
			$zobj->addFile("$basedir/$year/$month/$tozip",$zipped);
			$zobj->writeToFileNamed("$basedir/$year/$month/$zipped.zip");
			unlink("$basedir/$year/$month/$tozip");
		}
		unlink("$basedir/$file");
	} elsif ( $file =~ m/.jrn/ ) {
		move("$basedir/$file","$basedir/jrn/$file");
	} elsif ( $file =~ m/.err/ ) {
		move("$basedir/$file","$basedir/err/$file");
	}
		#Адрес data_loader
        my $telnetobj = new Net::Telnet (Host => "192.168.21.111", Port => "9033");

		my $prevhour = DateTime->now(time_zone  => $tz)->subtract( hours => 1 );
		my $prevhour_num=$prevhour->hour;
		my $prevhour_str;
		if ($prevhour_num<10) {
			$prevhour_str="0".$prevhour_num;
		} else {
			$prevhour_str=$prevhour_num;
		}
		my $prevhdate=$prevhour->ymd('-');
		# 5\n это код источника
		my $telnetstring1 = "load=$prevhdate-$prevhour_str-5\n";
		print "PREVHOURSTRING: $telnetstring1\n";
	        $telnetobj->open();
      		$telnetobj->put($telnetstring1);
	      	$telnetobj->close;
		sleep(3);

	my $telnetstring2="load=$year-$month-$day-$curhour_str-5\n";
	print "CURHOURSTRING: $telnetstring2\n";
	$telnetobj->open();
	$telnetobj->put($telnetstring2); 
	$telnetobj->close;
}

$ftpobj -> quit;
